(***************************************************************************
 * THIS SOURCE IS RELEASED ON THE TERMS OF THE GNU PUBLIC LICENSE V. 2!    *
 * See the file COPYING for information or visit http://www.fsf.org        *
 ***************************************************************************)

program dpage; { (c) vertigo 1998 }

{$M 65520,0,655350}
uses dos,crt,rafdradd,rafdoor,online1,semachk1,writend1,rafrun,chatter2,usredit1;

const
  Cfgfilename = 'DPAGE.CFG';
  HexTbl : array[0..15] of char=('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
  BS   =  8;
  CR   = 13;
  SP   = 32;
  Esc  = 27;


type

 keytype = (numlock, scrollock);

 cfgrec        = record
                   chatprog  : string[80];
                   usekey    : keytype;
                   delay     : longint;
                   silent    : boolean;
                   wipescr   : boolean;
                   padcolor  : byte;
                   text      : byte;
                   padchar   : char;
                   promptpos : array[1..2] of byte;
                   barpos    : array[1..2] of byte;
                   barattr   : array[1..5] of byte;
                 end;

 configfiletype = file of cfgrec;


var config : ^cfgrec;
    athome : boolean;
    haschatted : boolean;

(*********************************************************************
 *  Misc stuff.                                                      *
 *********************************************************************)

function HexB(b:byte):string; { from synopsis' doorkit }
begin
  HexB[0]:=#2;
  HexB[1]:=HexTbl[b shr 4];
  HexB[2]:=HexTbl[b and $f];
end;

Function Attr2Pcb(attr:byte):String; { from synopsis' doorkit }
begin
  Attr2Pcb:='@X'+HexB(attr);
end;


(*********************************************************************
 *  Key detection thingies.                                          *
 *********************************************************************)

function nlockon : boolean;
begin
  nlockon := (mem[$0040:$0017] and $20) <> 0;
end;

function slockon : boolean;
begin
  slockon := (mem[$0040:$0017] and $10) <> 0;
end;

function sysophome : boolean;
begin
  sysophome := false;
  if (((config^.usekey = numlock) and nlockon) or
     ((config^.usekey = scrollock) and slockon)) then
     sysophome := true;
end;

procedure waitforenter;
var tmpchar : longint;
    enter : boolean;
begin
  enter := false;
  while (not enter) do
  begin
    tmpchar := totalreadkey;
    if char(tmpchar) = #13 then enter := true;
  end;
end;

(*********************************************************************
 *  Read in the configfile.                                          *
 *********************************************************************)

function readconfigfile : boolean;
var f : configfiletype;
var s : string;
begin
  readconfigfile := false;
  assign(f,r_exepath + cfgfilename);
  {$I-} reset(f); {$I+}
  if (ioresult=0) then
  begin
    read(f, config^);
    close(f);
    readconfigfile := true;
  end;
end;

procedure readconfig;
begin
  new(config);
  if (not readconfigfile) then
   begin
     dispose(config);
     clearscreen;
     fdisplay('@X08'+#10#13);
     fdisplay('      @X0F@X07 Bummer. An error occurred trying to read the configfile.       '+#10#13);
     fdisplay('@X08'+#10#13);
     halt(0);
   end;
end;

(*********************************************************************
 *  Get the page reason.                                             *
 *********************************************************************)

function getstr(size : word):string;
var tmp: longint;
    x,y,pos : byte;
    enter   : boolean;
    str     : string;
begin
  str := '';
  pos := 1;
  enter := false;
  getxy(x,y);
  while (not enter) do
  begin
    tmp:=totalreadkey;
    case tmp of
     8 : begin
           if pos > 0 then
           begin
             dec(pos);
             cursorpos(y,x+pos);
             fdisplay(attr2pcb(config^.padcolor)+config^.padchar);
             cursorpos(y,x+pos);
             delete(str,pos+1,1);
           end;
         end;
  27,13 : enter := true;
  0..12 : begin end;
     else
         begin
           if pos>=size then
            begin
               cursorpos(y,x+pos-1);
               fdisplay(attr2pcb(config^.text)+char(tmp));
               delete(str,pos,1);
               str := str + char(tmp);
            end else begin
              fdisplay(attr2pcb(config^.text)+char(tmp));
              str := str + char(tmp);
              inc(pos);
            end;
         end;
     end;
  end;
  getstr := str;
end;


(*********************************************************************
 *  Sysop paging stuff.                                              *
 *********************************************************************)

procedure startchatter;
begin
  haschatted := true;
  Exec(config^.chatprog);
end;

procedure drawpagechar;
 const carr : array[1..5] of char =('','','','','');
 var x,y,tmp,oldcol : byte;
begin
  oldcol:= 0;
  for tmp := 1 to 5 do
  begin
    if oldcol <> config^.barattr[tmp] then
      begin
        oldcol := config^.barattr[tmp];
        fdisplay(attr2pcb(config^.barattr[tmp]));
      end;
    getxy(x,y);
    cursorpos(y,x-1);
    fdisplay(carr[tmp]);
    dvwait(1,r_remotelocal);
  end;
end;

procedure dobeep;
const freqarr : array[1..4] of word = (100,400,700,900);
var tmp : word;
begin
  for tmp:= 1 to 4 do
  begin
     Sound(freqarr[tmp]);        { Beep! }
     dvwait(1,r_remotelocal);
  end;
  nosound;
end;

procedure pagesysop;
var tmp:byte;
    tempstr : string;
    tmpch   : longint;
    interrupted : boolean;
begin
  tmp := 0;
  showfile(0,0,0,'DPAGE.ANS',R_EXEPATH);
  cursorpos(config^.promptpos[2],config^.promptpos[1]+tmp);
  tempstr:=getstr(36);
  interrupted := false;
  if length(tempstr) > 0 then
  begin
    addralog('DPage : Reason: "'+tempstr+'".');
    for tmp := 0 to 36 do
    begin
       cursorpos(config^.barpos[2],config^.barpos[1]+tmp);
       drawpagechar;
       dvwait(config^.delay,r_remotelocal);
       if athome then dobeep else dvwait(15,r_remotelocal);;
       if (inready or keypressed) then
       begin
         tmpch := totalreadkey;
         if (r_lkey and (char(tmpch) = ' ')) then
         begin
            clearscreen;
            startchatter;
            break;
         end else
         if (r_lkey and (char(tmpch) = #27)) then
         begin
           interrupted := true;
           break;
         end else
         if (not r_lkey) then
         begin
           interrupted := true;
           break;
         end;
       end;
    end;
    if ((not haschatted) and (not interrupted)) then
    begin
      showfile(0,0,0,'GONE.ANS',R_EXEPATH);
      waitforenter;
    end;
  end else addralog('DPage : User entered no reason.');
end;


(*********************************************************************
 *  Exit stuff.                                                      *
 *********************************************************************)

procedure funkywipe;
var tmp,q,t : byte;
begin
  t := 24;
  q := 1;
  fdisplay('@X07');
  for tmp := 1 to 12 do
  begin
    cursorpos(q,1); clreol;
    cursorpos(t,1); clreol;
    inc(q);
    dec(t);
    dvwait(1,r_remotelocal);
  end;
end;

procedure drawcopy;
begin
  clearscreen;
  fdisplay('@X07Thanks for using this [@X0FDementia@X07] production.'+#10#13);
  fdisplay('@X07Code by [@X0FVertigo@X07]');
  dvwait(1,r_remotelocal);
end;

procedure doexit;
begin
  if config^.wipescr then funkywipe else drawcopy;
  dispose(config);
  halt(0);
end;


(*********************************************************************
 *  Main Program.                                                    *
 *********************************************************************)

begin
   r_name:='DPage';
   r_version:='v0.0.2';
   rafdoorinit;
   ra_init;

   clearscreen;
   readconfig;
   haschatted := false;
   athome := sysophome;

   semawrite('DPage! - Yelling the sysop..');
   addralog('DPage : User entered pagedoor.');

   if (athome or config^.silent) then pagesysop else
       begin
         showfile(0,0,0,'GONE.ANS',R_EXEPATH);
         waitforenter;
         doexit;
       end;

   doexit;
end.

